Subject: bug#63660: Manual: Example for multiple SLiM instances doesn't work

From: Ivan Vilata i Balaguer <[email-masked]>
Date: Tue, 23 May 2023 13:55:42 +0200

Hi!  Under section "X Window", the Guix Manual provides an example on "how to
replace the default GDM service with two SLiM services on tty7 and tty8":

```
(use-modules (gnu services)
                       (gnu services desktop)
                       (gnu services xorg))

(operating-system
  ;; ...
  (services (cons* (service slim-service-type (slim-configuration
                                               (display ":0")
                                               (vt "vt7")))
                   (service slim-service-type (slim-configuration
                                               (display ":1")
                                               (vt "vt8")))
                   (modify-services %desktop-services
                     (delete gdm-service-type)))))
```

Unfortunately, reconfiguring a system (on commit 14c03807) reports the
following error:

    guix system: error: service 'xorg-server' provided more than once

Actually, leaving just the first `service` entry still produces the same
error.  One needs to also add a second argument to `xorg-configuration`, like
this:

```
(set-xorg-configuration
 (xorg-configuration […])
 slim-service-type)
```

And then the `service` entry can actually be removed.  To summarize, these are
the changes that I needed for actually having *one* operational SLiM instance:

```
(operating-system
 (packages (cons*
            (specification->package "slim")
            %base-packages))

 (services (cons*
            (set-xorg-configuration
             (xorg-configuration […])
             slim-service-type)

            (modify-services
             %desktop-services
             (delete gdm-service-type)))))
```

For completeness sake, adding the two `service` entries causes the error:

    guix system: error: more than one target service of type 'slim'

as already discussed in <https://issues.guix.gnu.org/55391>.  There's a
possible workaround explained there which implies duplicating the Xorg server
configuration.

But maybe I missed some point in the instructions.  Otherwise, I wonder
whether they should be either fixed, or updated for a single-instance example
that does work (which may be ok as that's probably the most common use case).

Thanks, and cheers!

-- 
Ivan Vilata i Balaguer -- https://elvil.net/